<?php
namespace Bushelpowered\Api\Aggregator\Accountpayablebalance\V1\Model;
        
class AccountPayableBalanceListItem 
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $displayId The unique identifier to show users.*/
    public string $displayId;
    /** @var null|string $accountId The account identifier.*/
    public ?string $accountId = null;
    /** @var string $accountName The name of the account.*/
    public string $accountName;
    /** @var string $currency The currency associated with the balances e.g. USD, CAD.*/
    public string $currency;
    /** @var string $accountBalance The formatted financial obligation due by the account.*/
    public string $accountBalance;
    /** @var float $accountBalanceNumeric The financial obligation due by the account.*/
    public float $accountBalanceNumeric;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $displayId The unique identifier to show users.
     * @param  null|string  $accountId The account identifier.
     * @param  string  $accountName The name of the account.
     * @param  string  $currency The currency associated with the balances e.g. USD, CAD.
     * @param  string  $accountBalance The formatted financial obligation due by the account.
     * @param  float  $accountBalanceNumeric The financial obligation due by the account.
     */
    public function __construct(string $id, string $displayId, ?string $accountId, string $accountName, string $currency, string $accountBalance, float $accountBalanceNumeric)
    {
        $this->id = $id;
        $this->displayId = $displayId;
        $this->accountId = $accountId;
        $this->accountName = $accountName;
        $this->currency = $currency;
        $this->accountBalance = $accountBalance;
        $this->accountBalanceNumeric = $accountBalanceNumeric;
    }
    

}