<?php
namespace Bushelpowered\Api\Aggregator\Businesspages\V1\Model;
        
class BusinessLocationListItem 
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $locationId The id of the Associated Tenant Service Location.*/
    public string $locationId;
    /** @var bool $isFavorite Indicates if the location is a favorite.*/
    public bool $isFavorite;
    /** @var null|string $locationName location name*/
    public ?string $locationName = null;
    /** @var null|string $locationAddress location address*/
    public ?string $locationAddress = null;
    /** @var null|string $todaysHours The hours for a specific day.*/
    public ?string $todaysHours = null;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $locationId The id of the Associated Tenant Service Location.
     * @param  bool  $isFavorite Indicates if the location is a favorite.
     * @param  null|string  $locationName location name
     * @param  null|string  $locationAddress location address
     * @param  null|string  $todaysHours The hours for a specific day.
     */
    public function __construct(string $id, string $locationId, bool $isFavorite, ?string $locationName, ?string $locationAddress, ?string $todaysHours)
    {
        $this->id = $id;
        $this->locationId = $locationId;
        $this->isFavorite = $isFavorite;
        $this->locationName = $locationName;
        $this->locationAddress = $locationAddress;
        $this->todaysHours = $todaysHours;
    }
    

}