<?php
namespace Bushelpowered\Api\Aggregator\Businesspages\V1\Request;
        
class StaffCreateDiscountScheduleRequest 
{
    /** @var string $name The name of the discount schedule.*/
    public string $name;
    /** @var string[] $locationIds The location ids that the discount schedule is associated with.*/
    public array $locationIds;
    /** @var bool $isPublic Whether the discount schedule is public.*/
    public bool $isPublic;
    /** @var null|string $notes The notes for the discount schedule.*/
    public ?string $notes = null;
    /** @var string $file A base64 encoded pdf for the discount schedule.*/
    public string $file;
    /** @var string $fileName The name of the file as it was saved on the computer that uploaded it.*/
    public string $fileName;
    /** @var bool $publish Whether to publish the discount schedule.*/
    public bool $publish;

    /**
     * @param  string  $name The name of the discount schedule.
     * @param  string[]  $locationIds The location ids that the discount schedule is associated with.
     * @param  bool  $isPublic Whether the discount schedule is public.
     * @param  null|string  $notes The notes for the discount schedule.
     * @param  string  $file A base64 encoded pdf for the discount schedule.
     * @param  string  $fileName The name of the file as it was saved on the computer that uploaded it.
     * @param  bool  $publish Whether to publish the discount schedule.
     */
    public function __construct(string $name, array $locationIds, bool $isPublic, ?string $notes, string $file, string $fileName, bool $publish)
    {
        $this->name = $name;
        $this->locationIds = $locationIds;
        $this->isPublic = $isPublic;
        $this->notes = $notes;
        $this->file = $file;
        $this->fileName = $fileName;
        $this->publish = $publish;
    }
    

}