<?php

namespace Bushelpowered\Api\Aggregator\Iam\V1\Response;

class RoleBindingResource
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'tenant' => '\Bushelpowered\Api\Aggregator\Iam\V1\Response\TenantResource',
        'location' => '\Bushelpowered\Api\Aggregator\Iam\V1\Response\LocationResource',
        'account' => '\Bushelpowered\Api\Aggregator\Iam\V1\Response\AccountResource',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Tenant(\Bushelpowered\Api\Aggregator\Iam\V1\Response\TenantResource $data): RoleBindingResource
    {
        return new RoleBindingResource('tenant', $data);
    }
    public static function Location(\Bushelpowered\Api\Aggregator\Iam\V1\Response\LocationResource $data): RoleBindingResource
    {
        return new RoleBindingResource('location', $data);
    }
    public static function Account(\Bushelpowered\Api\Aggregator\Iam\V1\Response\AccountResource $data): RoleBindingResource
    {
        return new RoleBindingResource('account', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    