<?php
namespace Bushelpowered\Api\Aggregator\Payments\V1\Model;
        
class PaymentsListItem 
{
    /** @var string $id */
    public string $id;
    /** @var \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentOrigin $origin */
    public \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentOrigin $origin;
    /** @var \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentType $paymentType */
    public \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentType $paymentType;
    /** @var \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentTiming $paymentTiming */
    public \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentTiming $paymentTiming;
    /** @var string $item A human readable name that will briefly describe this payment*/
    public string $item;
    /** @var string $paymentMethod How the payment was made*/
    public string $paymentMethod;
    /** @var string $amount The amount of this payment*/
    public string $amount;
    /** @var \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentStatus $status */
    public \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentStatus $status;
    /** @var null|string $processOn Scheduled payments only: When the payment WILL be processed of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $processOn = null;
    /** @var null|string $completedAt Processed payments only: When the payment was completed of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $completedAt = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id 
     * @param  \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentOrigin  $origin 
     * @param  \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentType  $paymentType 
     * @param  \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentTiming  $paymentTiming 
     * @param  string  $item A human readable name that will briefly describe this payment
     * @param  string  $paymentMethod How the payment was made
     * @param  string  $amount The amount of this payment
     * @param  \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentStatus  $status 
     * @param  null|string  $processOn Scheduled payments only: When the payment WILL be processed of yyyy-MM-dd format, IE: 2023-10-04
     * @param  null|string  $completedAt Processed payments only: When the payment was completed of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentOrigin $origin, \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentType $paymentType, \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentTiming $paymentTiming, string $item, string $paymentMethod, string $amount, \Bushelpowered\Api\Aggregator\Payments\V1\Enums\PaymentStatus $status, ?string $processOn, ?string $completedAt, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->origin = $origin;
        $this->paymentType = $paymentType;
        $this->paymentTiming = $paymentTiming;
        $this->item = $item;
        $this->paymentMethod = $paymentMethod;
        $this->amount = $amount;
        $this->status = $status;
        $this->processOn = $processOn;
        $this->completedAt = $completedAt;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    

}