<?php
namespace Bushelpowered\Api\Aggregator\Payments\V1\Response;
        
class FundingSource 
{
    /** @var string $id The UUID of the funding source*/
    public string $id;
    /** @var \Bushelpowered\Api\Aggregator\Payments\V1\Enums\FundingSourceOrigin $origin */
    public \Bushelpowered\Api\Aggregator\Payments\V1\Enums\FundingSourceOrigin $origin;
    /** @var string $name The display name of the funding source*/
    public string $name;
    /** @var string $lastFour The last four numbers that are on the card or wallet account*/
    public string $lastFour;
    /** @var string $financialInstitutionName The financial institution that is associated with this funding source*/
    public string $financialInstitutionName;
    /** @var null|string $balance Wallet only: The amount that is currently available in this account*/
    public ?string $balance = null;
    /** @var null|string $expiration Card only: When the card expires*/
    public ?string $expiration = null;
    /** @var null|\Bushelpowered\Api\Aggregator\Payments\V1\Enums\CardType $cardType */
    public ?\Bushelpowered\Api\Aggregator\Payments\V1\Enums\CardType $cardType = null;

    /**
     * @param  string  $id The UUID of the funding source
     * @param  \Bushelpowered\Api\Aggregator\Payments\V1\Enums\FundingSourceOrigin  $origin 
     * @param  string  $name The display name of the funding source
     * @param  string  $lastFour The last four numbers that are on the card or wallet account
     * @param  string  $financialInstitutionName The financial institution that is associated with this funding source
     * @param  null|string  $balance Wallet only: The amount that is currently available in this account
     * @param  null|string  $expiration Card only: When the card expires
     * @param  null|\Bushelpowered\Api\Aggregator\Payments\V1\Enums\CardType  $cardType 
     */
    public function __construct(string $id, \Bushelpowered\Api\Aggregator\Payments\V1\Enums\FundingSourceOrigin $origin, string $name, string $lastFour, string $financialInstitutionName, ?string $balance, ?string $expiration, ?\Bushelpowered\Api\Aggregator\Payments\V1\Enums\CardType $cardType)
    {
        $this->id = $id;
        $this->origin = $origin;
        $this->name = $name;
        $this->lastFour = $lastFour;
        $this->financialInstitutionName = $financialInstitutionName;
        $this->balance = $balance;
        $this->expiration = $expiration;
        $this->cardType = $cardType;
    }
    

}