<?php
namespace Bushelpowered\Api\Crm\V1\Response;
        
class UserAssignmentResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasCreatedBy
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $customerId The UUID of the customer associated to the userId*/
    public string $customerId;
    /** @var string $userId The UUID of the user associated to the customerId*/
    public string $userId;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $createdBy Created by UUID within the microservice.*/
    public string $createdBy;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $customerId The UUID of the customer associated to the userId
     * @param  string  $userId The UUID of the user associated to the customerId
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdBy Created by UUID within the microservice.
     */
    public function __construct(string $id, string $customerId, string $userId, string $createdAt, string $createdBy)
    {
        $this->id = $id;
        $this->customerId = $customerId;
        $this->userId = $userId;
        $this->createdAt = $createdAt;
        $this->createdBy = $createdBy;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Created by UUID within the microservice.
     */
    public function getCreatedBy(): string
    {
        return $this->createdBy;
    }
}