<?php
namespace Bushelpowered\Api\Data\Analytics\V1\Request;
        
class InvoicesFilters 
{
    /** @var string[]|null $tenantIds Tenant id in list*/
    public ?array $tenantIds = null;
    /** @var null|string $displayId Invoice display id, partial match*/
    public ?string $displayId = null;
    /** @var string[]|null $accountIds Account id in list*/
    public ?array $accountIds = null;
    /** @var \Bushelpowered\Api\Data\Analytics\V1\Enums\InvoiceStatus[]|null $status Invoice status in list*/
    public ?array $status = null;
    /** @var null|string $invoiceDateEqualOrAfter Invoice date is equal or after (inclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $invoiceDateEqualOrAfter = null;
    /** @var null|string $invoiceDateBefore Invoice date is before (exclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $invoiceDateBefore = null;
    /** @var null|string $dueDateEqualOrAfter Due date is equal or after (inclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $dueDateEqualOrAfter = null;
    /** @var null|string $dueDateBefore Due date is before (exclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $dueDateBefore = null;
    /** @var null|float $totalAmountEqualOrGreater Total amount is equal or greater (inclusive)*/
    public ?float $totalAmountEqualOrGreater = null;
    /** @var null|float $totalAmountLess Total amount is less (exclusive)*/
    public ?float $totalAmountLess = null;

    /**
     * @param  string[]|null  $tenantIds Tenant id in list
     * @param  null|string  $displayId Invoice display id, partial match
     * @param  string[]|null  $accountIds Account id in list
     * @param  \Bushelpowered\Api\Data\Analytics\V1\Enums\InvoiceStatus[]|null  $status Invoice status in list
     * @param  null|string  $invoiceDateEqualOrAfter Invoice date is equal or after (inclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $invoiceDateBefore Invoice date is before (exclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $dueDateEqualOrAfter Due date is equal or after (inclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $dueDateBefore Due date is before (exclusive) of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|float  $totalAmountEqualOrGreater Total amount is equal or greater (inclusive)
     * @param  null|float  $totalAmountLess Total amount is less (exclusive)
     */
    public function __construct(?array $tenantIds, ?string $displayId, ?array $accountIds, ?array $status, ?string $invoiceDateEqualOrAfter, ?string $invoiceDateBefore, ?string $dueDateEqualOrAfter, ?string $dueDateBefore, ?float $totalAmountEqualOrGreater, ?float $totalAmountLess)
    {
        $this->tenantIds = $tenantIds;
        $this->displayId = $displayId;
        $this->accountIds = $accountIds;
        $this->status = $status;
        $this->invoiceDateEqualOrAfter = $invoiceDateEqualOrAfter;
        $this->invoiceDateBefore = $invoiceDateBefore;
        $this->dueDateEqualOrAfter = $dueDateEqualOrAfter;
        $this->dueDateBefore = $dueDateBefore;
        $this->totalAmountEqualOrGreater = $totalAmountEqualOrGreater;
        $this->totalAmountLess = $totalAmountLess;
    }
    

}