<?php

namespace Bushelpowered\Api\Finops\Aggregator\V1\Projections;

class FileUpdate
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'remove' => '\Bushelpowered\Api\Finops\Aggregator\V1\Projections\RemoveFile',
        'update' => '\Bushelpowered\Api\Finops\Aggregator\V1\Projections\UpdateFile',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Remove(\Bushelpowered\Api\Finops\Aggregator\V1\Projections\RemoveFile $data): FileUpdate
    {
        return new FileUpdate('remove', $data);
    }
    public static function Update(\Bushelpowered\Api\Finops\Aggregator\V1\Projections\UpdateFile $data): FileUpdate
    {
        return new FileUpdate('update', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    