<?php

namespace Bushelpowered\Api\Finops\Aggregator\V1\Projections;

class LenderSpecificDealerInfo
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'compeer' => '\Bushelpowered\Api\Finops\Aggregator\V1\Projections\CompeerSpecificDealerInfo',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Compeer(\Bushelpowered\Api\Finops\Aggregator\V1\Projections\CompeerSpecificDealerInfo $data): LenderSpecificDealerInfo
    {
        return new LenderSpecificDealerInfo('compeer', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    