<?php
namespace Bushelpowered\Api\Fulfillment\Ticket\V1\Response;
        
class ExceededThresholdResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $thresholdId The id of the threshold that would have created this.*/
    public string $thresholdId;
    /** @var string $remarkCode The remark code that this is tied to.*/
    public string $remarkCode;
    /** @var float $thresholdValue The value on the threshold when it was exceeded.*/
    public float $thresholdValue;
    /** @var float $remarkValue The value on the remark when it was exceeded.*/
    public float $remarkValue;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $thresholdId The id of the threshold that would have created this.
     * @param  string  $remarkCode The remark code that this is tied to.
     * @param  float  $thresholdValue The value on the threshold when it was exceeded.
     * @param  float  $remarkValue The value on the remark when it was exceeded.
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $thresholdId, string $remarkCode, float $thresholdValue, float $remarkValue, string $createdAt, string $updatedAt)
    {
        $this->thresholdId = $thresholdId;
        $this->remarkCode = $remarkCode;
        $this->thresholdValue = $thresholdValue;
        $this->remarkValue = $remarkValue;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}