<?php
namespace Bushelpowered\Api\Iam\Access\Common\V1;
        
class RoleBinding implements \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\HasResource
{
    /** @var \Bushelpowered\Api\Iam\Access\Common\V1\Subjectable $subject */
    public \Bushelpowered\Api\Iam\Access\Common\V1\Subjectable $subject;
    /** @var \Bushelpowered\Api\Iam\Access\Common\V1\RoleRef[] $roles The list of roles. Specify a RoleRef with a roleId of 00000000-0000-0000-0000-000000000000 and a tenantId matching that of the tenant to create a binding using the tenant's default role.*/
    public array $roles;
    /** @var \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef $resource */
    public \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef $resource;

    /**
     * @param  \Bushelpowered\Api\Iam\Access\Common\V1\Subjectable  $subject 
     * @param  \Bushelpowered\Api\Iam\Access\Common\V1\RoleRef[]  $roles The list of roles. Specify a RoleRef with a roleId of 00000000-0000-0000-0000-000000000000 and a tenantId matching that of the tenant to create a binding using the tenant's default role.
     * @param  \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef  $resource 
     */
    public function __construct(\Bushelpowered\Api\Iam\Access\Common\V1\Subjectable $subject, array $roles, \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef $resource)
    {
        $this->subject = $subject;
        $this->roles = $roles;
        $this->resource = $resource;
    }
    
    /**
     * @return \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef 
     */
    public function getResource(): \Bushelpowered\Api\Iam\Access\Common\V1\Mixins\ResourceRef
    {
        return $this->resource;
    }
}