<?php
namespace Bushelpowered\Api\Iam\Access\Common\V1;
        
class SubjectGroupRef implements \Bushelpowered\Api\Iam\Access\Common\V1\HasOptionalTenantId
{
    /** @var string $subjectGroupId The id of the subject group*/
    public string $subjectGroupId;
    /** @var null|string $tenantId The id of the tenant or null when owned by root.*/
    public ?string $tenantId = null;

    /**
     * @param  string  $subjectGroupId The id of the subject group
     * @param  null|string  $tenantId The id of the tenant or null when owned by root.
     */
    public function __construct(string $subjectGroupId, ?string $tenantId)
    {
        $this->subjectGroupId = $subjectGroupId;
        $this->tenantId = $tenantId;
    }
    
    /**
     * @return null|string The id of the tenant or null when owned by root.
     */
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
}