<?php
namespace Bushelpowered\Api\Iam\Access\Manage\V1\Response;
        
class TenantConfigurationResponse implements \Bushelpowered\Api\Common\HasTimestamps
{
    /** @var string $tenantId */
    public string $tenantId;
    /** @var \Bushelpowered\Api\Iam\Access\Manage\V1\Response\TenantRoleMappingConfiguration $roleMappings */
    public \Bushelpowered\Api\Iam\Access\Manage\V1\Response\TenantRoleMappingConfiguration $roleMappings;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;

    /**
     * @param  string  $tenantId 
     * @param  \Bushelpowered\Api\Iam\Access\Manage\V1\Response\TenantRoleMappingConfiguration  $roleMappings 
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $tenantId, \Bushelpowered\Api\Iam\Access\Manage\V1\Response\TenantRoleMappingConfiguration $roleMappings, string $createdAt, string $updatedAt, ?string $deletedAt)
    {
        $this->tenantId = $tenantId;
        $this->roleMappings = $roleMappings;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
}