<?php
namespace Bushelpowered\Api\Iam\Serviceaccounts\V1;

use \Bushelpowered\Api\Iam\Serviceaccounts\V1\Request\GetServiceAccountPublicKeyRequest;
use \Bushelpowered\Api\Iam\Serviceaccounts\V1\Response\GetServiceAccountKeyPublicKeyResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotFound;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetServiceAccountPublicKey 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(GetServiceAccountPublicKeyRequest $request, $headers): GetServiceAccountKeyPublicKeyResponse | BadRequest | NotFound | UnknownError
    {
         return $this->client->call('api/iam/serviceaccounts/v1/GetServiceAccountPublicKey', $request, $this->getWrapper(), $headers);
    }
    
    public function request(GetServiceAccountPublicKeyRequest $request, GetServiceAccountPublicKeyMetadata $hasHeaders): GetServiceAccountKeyPublicKeyResponse | BadRequest | NotFound | UnknownError
    {
         return $this->client->call('api/iam/serviceaccounts/v1/GetServiceAccountPublicKey', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var GetServiceAccountKeyPublicKeyResponse | BadRequest | NotFound | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.iam.serviceaccounts.v1#GetServiceAccountPublicKeySuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Iam\Serviceaccounts\V1\Response\GetServiceAccountKeyPublicKeyResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotFound':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}