<?php
namespace Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response;
        
class BidsListBidGroup 
{
    /** @var string $id */
    public string $id;
    /** @var string $displayName */
    public string $displayName;
    /** @var \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListCommodity $commodity */
    public \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListCommodity $commodity;
    /** @var null|string $bidPriceUoM */
    public ?string $bidPriceUoM = null;
    /** @var null|string $bidPriceCurrency */
    public ?string $bidPriceCurrency = null;
    /** @var null|string $basisPriceUoM */
    public ?string $basisPriceUoM = null;
    /** @var null|string $basisPriceCurrency */
    public ?string $basisPriceCurrency = null;
    /** @var null|string $futuresPriceUoM */
    public ?string $futuresPriceUoM = null;
    /** @var null|string $futuresPriceCurrency */
    public ?string $futuresPriceCurrency = null;
    /** @var \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListBid[] $bids */
    public array $bids;

    /**
     * @param  string  $id 
     * @param  string  $displayName 
     * @param  \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListCommodity  $commodity 
     * @param  null|string  $bidPriceUoM 
     * @param  null|string  $bidPriceCurrency 
     * @param  null|string  $basisPriceUoM 
     * @param  null|string  $basisPriceCurrency 
     * @param  null|string  $futuresPriceUoM 
     * @param  null|string  $futuresPriceCurrency 
     * @param  \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListBid[]  $bids 
     */
    public function __construct(string $id, string $displayName, \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListCommodity $commodity, ?string $bidPriceUoM, ?string $bidPriceCurrency, ?string $basisPriceUoM, ?string $basisPriceCurrency, ?string $futuresPriceUoM, ?string $futuresPriceCurrency, array $bids)
    {
        $this->id = $id;
        $this->displayName = $displayName;
        $this->commodity = $commodity;
        $this->bidPriceUoM = $bidPriceUoM;
        $this->bidPriceCurrency = $bidPriceCurrency;
        $this->basisPriceUoM = $basisPriceUoM;
        $this->basisPriceCurrency = $basisPriceCurrency;
        $this->futuresPriceUoM = $futuresPriceUoM;
        $this->futuresPriceCurrency = $futuresPriceCurrency;
        $this->bids = $bids;
    }
    

}