<?php
namespace Bushelpowered\Api\Platform\Connection\V1;

use \Bushelpowered\Api\Common\Request\EmptyRequest;
use \Bushelpowered\Api\Platform\Connection\V1\Response\ConsumerResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotFound;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetConsumerData 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(EmptyRequest $request, $headers): ConsumerResponse | BadRequest | NotFound | UnknownError
    {
         return $this->client->call('api/platform/connection/v1/GetConsumerData', $request, $this->getWrapper(), $headers);
    }
    
    public function request(EmptyRequest $request, GetConsumerDataMetadata $hasHeaders): ConsumerResponse | BadRequest | NotFound | UnknownError
    {
         return $this->client->call('api/platform/connection/v1/GetConsumerData', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var ConsumerResponse | BadRequest | NotFound | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.platform.connection.v1#GetConsumerDataSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Platform\Connection\V1\Response\ConsumerResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotFound':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}