<?php
namespace Bushelpowered\Api\Platform\Location\V1\Request;
        
class GetOrCreateLocationRequest 
{
    /** @var string $datasourceId The datasource identifier.*/
    public string $datasourceId;
    /** @var string $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.*/
    public string $integrationId;
    /** @var string $sourceId The source record identifier.*/
    public string $sourceId;
    /** @var null|string $sourceName The record's source name*/
    public ?string $sourceName = null;

    /**
     * @param  string  $datasourceId The datasource identifier.
     * @param  string  $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.
     * @param  string  $sourceId The source record identifier.
     * @param  null|string  $sourceName The record's source name
     */
    public function __construct(string $datasourceId, string $integrationId, string $sourceId, ?string $sourceName)
    {
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceName = $sourceName;
    }
    

}