<?php
namespace Bushelpowered\Api\Platform\User\V1;

use \Bushelpowered\Api\Platform\User\V1\Request\GetTenantUserByEmailRequest;
use \Bushelpowered\Api\Platform\User\V1\Response\GetTenantUserByEmailResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\NotFound;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetTenantUserByEmail 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(GetTenantUserByEmailRequest $request, $headers): GetTenantUserByEmailResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | NotFound | UnknownError
    {
         return $this->client->call('api/platform/user/v1/GetTenantUserByEmail', $request, $this->getWrapper(), $headers);
    }
    
    public function request(GetTenantUserByEmailRequest $request, GetTenantUserByEmailMetadata $hasHeaders): GetTenantUserByEmailResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | NotFound | UnknownError
    {
         return $this->client->call('api/platform/user/v1/GetTenantUserByEmail', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var GetTenantUserByEmailResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | NotFound | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.platform.user.v1#GetTenantUserByEmailSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Platform\User\V1\Response\GetTenantUserByEmailResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#ConstraintViolation':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotFound':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}