<?php
namespace Bushelpowered\Api\Quoting\V1\Request;
        
class GetProductsRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var null|\Bushelpowered\Api\Quoting\V1\Request\ProductFilters $filters */
    public ?\Bushelpowered\Api\Quoting\V1\Request\ProductFilters $filters = null;
    /** @var null|\Bushelpowered\Api\Quoting\V1\Request\ProductPagination $pagination */
    public ?\Bushelpowered\Api\Quoting\V1\Request\ProductPagination $pagination = null;

    /**
     * @param  null|\Bushelpowered\Api\Quoting\V1\Request\ProductFilters  $filters 
     * @param  null|\Bushelpowered\Api\Quoting\V1\Request\ProductPagination  $pagination 
     */
    public function __construct(?\Bushelpowered\Api\Quoting\V1\Request\ProductFilters $filters, ?\Bushelpowered\Api\Quoting\V1\Request\ProductPagination $pagination)
    {
        $this->filters = $filters;
        $this->pagination = $pagination;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Quoting\V1\Request\ProductPagination 
     */
    public function getPagination(): ?\Bushelpowered\Api\Quoting\V1\Request\ProductPagination
    {
        return $this->pagination;
    }
}