<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Request;
        
class BidsRequest 
{
    /** @var null|int $bidLimit The number of bids return, all of them if null.*/
    public ?int $bidLimit = null;
    /** @var bool $comprehensive Whether or not to return all bid types.*/
    public bool $comprehensive;
    /** @var bool $convertBasis Whether or not to convert the Basis Price.*/
    public bool $convertBasis;
    /** @var bool $includeHidden Whether or not to include hidden bids. Intended for backend use only.*/
    public bool $includeHidden;
    /** @var bool $includeHiddenLocations Optional filter param for including hidden bid locations in the response. Defaults to false.*/
    public bool $includeHiddenLocations;
    /** @var string[]|null $locationRemoteIds Optional filter param for restricting returned bids to only those for the locations with the provided remote ids.*/
    public ?array $locationRemoteIds = null;

    /**
     * @param  null|int  $bidLimit The number of bids return, all of them if null.
     * @param  bool  $comprehensive Whether or not to return all bid types.
     * @param  bool  $convertBasis Whether or not to convert the Basis Price.
     * @param  bool  $includeHidden Whether or not to include hidden bids. Intended for backend use only.
     * @param  bool  $includeHiddenLocations Optional filter param for including hidden bid locations in the response. Defaults to false.
     * @param  string[]|null  $locationRemoteIds Optional filter param for restricting returned bids to only those for the locations with the provided remote ids.
     */
    public function __construct(?int $bidLimit, bool $comprehensive, bool $convertBasis, bool $includeHidden, bool $includeHiddenLocations, ?array $locationRemoteIds)
    {
        $this->bidLimit = $bidLimit;
        $this->comprehensive = $comprehensive;
        $this->convertBasis = $convertBasis;
        $this->includeHidden = $includeHidden;
        $this->includeHiddenLocations = $includeHiddenLocations;
        $this->locationRemoteIds = $locationRemoteIds;
    }
    

}