<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Response;
        
class FuturesOverrideResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $id The unique identifier for a specific FuturesOverride.*/
    public string $id;
    /** @var string $companyId The unique identifier for a specific Company related to the FuturesOverride.*/
    public string $companyId;
    /** @var string $name The original name of the product as provided by CQG.*/
    public string $name;
    /** @var null|string $displayName The name of the product that is displayed through the API response.*/
    public ?string $displayName = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id The unique identifier for a specific FuturesOverride.
     * @param  string  $companyId The unique identifier for a specific Company related to the FuturesOverride.
     * @param  string  $name The original name of the product as provided by CQG.
     * @param  null|string  $displayName The name of the product that is displayed through the API response.
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $companyId, string $name, ?string $displayName, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->companyId = $companyId;
        $this->name = $name;
        $this->displayName = $displayName;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}