<?php

namespace Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto;

class DynamicMessagePart
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'text' => '\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\TextDynamicMessagePart',
        'link' => '\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\LinkDynamicMessagePart',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Text(\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\TextDynamicMessagePart $data): DynamicMessagePart
    {
        return new DynamicMessagePart('text', $data);
    }
    public static function Link(\Bushelpowered\Api\Wallet\Aggregator\V1\Dealers\Find\Dto\LinkDynamicMessagePart $data): DynamicMessagePart
    {
        return new DynamicMessagePart('link', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    