<?php

namespace Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto;

class InitiateLoanLinkInput
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'dynamic' => '\Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto\DynamicLoanLinkInitiationInput',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Dynamic(\Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto\DynamicLoanLinkInitiationInput $data): InitiateLoanLinkInput
    {
        return new InitiateLoanLinkInput('dynamic', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    