<?php
namespace Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate;

use \Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto\InitiateLoanLinkRequest;
use \Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto\InitiateLoanLinkResponse;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bidl\Php\Core\Builtins\UnknownError;

class InitiateLoanLink 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(InitiateLoanLinkRequest $request, $headers): InitiateLoanLinkResponse | NotAuthenticated | NotAuthorized | BadRequest | ConstraintViolation | UnknownError
    {
         return $this->client->call('api/wallet/aggregator/v1/loanlink/initiate/InitiateLoanLink', $request, $this->getWrapper(), $headers);
    }
    
    public function request(InitiateLoanLinkRequest $request, InitiateLoanLinkMetadata $hasHeaders): InitiateLoanLinkResponse | NotAuthenticated | NotAuthorized | BadRequest | ConstraintViolation | UnknownError
    {
         return $this->client->call('api/wallet/aggregator/v1/loanlink/initiate/InitiateLoanLink', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var InitiateLoanLinkResponse | NotAuthenticated | NotAuthorized | BadRequest | ConstraintViolation | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.wallet.aggregator.v1.loanlink.initiate#InitiateLoanLinkSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Wallet\Aggregator\V1\Loanlink\Initiate\Dto\InitiateLoanLinkResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#ConstraintViolation':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}