<?php

namespace Bushelpowered\Api\Wallet\Permissions\Check\Dto;

class PermissionsCheckInput
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'initiateLoanLink' => '\Bushelpowered\Api\Wallet\Permissions\Check\Dto\InitiateLoanLinkPermissionCheck',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function InitiateLoanLink(\Bushelpowered\Api\Wallet\Permissions\Check\Dto\InitiateLoanLinkPermissionCheck $data): PermissionsCheckInput
    {
        return new PermissionsCheckInput('initiateLoanLink', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    